#ifndef MAP_ATTRIBUTE_ALLOCATOR
#define MAP_ATTRIBUTE_ALLOCATOR

#include <iostream>
#include <vector>
#include <map>


using namespace std;
using namespace Tango;
			 
namespace TangoDevMapper_ns
{

class MappedAttr;
	
class MapAttributeAllocator
{
	public:
		MapAttributeAllocator(string entry, string defaultDevname);
		
		vector<MappedAttr*> attributes() { return attrs; }
		
		string error() { return err; }
		
		bool isValid() { return !_invalid; }
		string failureReason() { return _failure_reason; }
		void setFailureReason(string _fail) { _failure_reason = _fail; }

		
	private:
		vector<MappedAttr*> attrs;
		MappedAttr* createAttribute(string devname, string attname, 
					    string map, int index);
		vector<string> split(string s, const char delim);
		string err, _failure_reason;
		bool _invalid;
		char failure[256];
};

} /* namespace */

#endif

