#include <MappedAttr.h>
namespace TangoDevMapper_ns
{

MappedAttr::MappedAttr(const char *name,long data_type,Tango::AttrWriteType w_type,
			  AttrDataFormat data_f,
			  string devnam, string attnam,  int index) :
                        Attr(name, data_type, w_type) 
{
	char description[512];
	UserDefaultAttrProp default_att_prop;
	devname = devnam;
	attname = attnam;
	_name = string(name);
	_index = index;
	_data_type = data_type;
	_write_type = w_type;
	_data_format = data_f;
	if(_data_format == Tango::SCALAR)
		snprintf(description, 512, "This attribute maps the"
				" attribute %s of the device %s (one to one map)."
				" Read attribute properties for a more detailed description",
    				attributeName().c_str(), deviceName().c_str());
	else if(_data_format == Tango::SPECTRUM)
		snprintf(description, 512, "This attribute maps the element %d (starting from 0) of the "
				" attribute %s of the device %s. Read attribute properties for a more detailed description",
    				index, attributeName().c_str(), deviceName().c_str());
	
	default_att_prop.set_description(description);
	set_default_properties(default_att_prop);
}

MappedAttr::~MappedAttr()
{
//	printf("deleting \"%s\"\n", name.c_str());
}

string MappedAttr::exception(const char* msg, Tango::DevFailed &e)
{
	string err, descr, orig;
	char exc[256];
        int i;
        for(i = e.errors.length() - 1; i >= 0;  i--)
        {
                err = e.errors[i].reason;
                descr = e.errors[i].desc;
                orig = e.errors[i].origin;
	}
	snprintf(exc, 256, "%s\n%s\n%s\n%s\n", msg, err.c_str(),
		descr.c_str(), orig.c_str());
	return string(exc);
}

} /* namespace ends */




