#ifndef _MAPPED_ATTR_H
#define _MAPPED_ATTR_H

#include <tango.h>
#include <stdio.h>
#include <stdlib.h>
#include "TangoDevMapper.h"

using namespace Tango;


namespace TangoDevMapper_ns
{

class MappedAttr : public Tango::Attr
{
	public:
		MappedAttr(const char *name,long data_type,Tango::AttrWriteType w_type,
			  AttrDataFormat data_f, string devnam, string attnam, int ind);
		
		~MappedAttr() ;
		virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
			{(static_cast<TangoDevMapper *>(dev))->read_MappedAttr(att);}
		virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
			{return (static_cast<TangoDevMapper *>(dev))->is_MappedAttr_allowed(ty);}
	
		string deviceName() { return devname; }
		string attributeName() { return attname; }
		string name() { return _name; }
		
		Tango::AttrWriteType writeType() { return _write_type; }
		
		/** dataType(): DEV_LONG, DEV_STRING... */
		long dataType() { return _data_type; }
		
		/** dataFormat() : SCALAR, SPECTRUM, IMAGE */
		Tango::AttrDataFormat dataFormat() { return _data_format; }
		
		int index() { return _index; }
		
		
		
		static string exception(const char* msg, Tango::DevFailed &e);
		
	private:
		string devname, attname, _name;
		int _index;
		long _data_type;
		Tango::AttrWriteType _write_type;
		Tango::AttrDataFormat _data_format;
};










}

#endif

