//=============================================================================
//
// file :        TangoDevMapper.h
//
// description : Include for the TangoDevMapper class.
//
// project :	A mapper to map certain attributes into others
//
// $Author: claudio $
//
// $Revision: 1.4 $
//
// $Log: TangoDevMapper.h,v $
// Revision 1.4  2017-07-31 13:01:10  claudio
// ticket #1554: porting to tango-9.2.5.a/QTANGO_BASE_CLASS
//
// Revision 1.3  2013-06-27 15:17:41  claudio
// pulizia alcuni warning
//
// Revision 1.2  2012-05-07 10:33:52  claudio
// tango-7.2.6
// meno printf
//
// Revision 1.1.1.1  2008/04/28 09:17:53  giacomo
// Prima release di TangoDevMapper. Aprile 2008
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _TANGODEVMAPPER_H
#define _TANGODEVMAPPER_H

#include <tango.h>
#include <map>

//using namespace Tango;

/**
 * @author	$Author: claudio $
 * @version	$Revision: 1.4 $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------



namespace TangoDevMapper_ns
{

	using namespace std;
	using namespace Tango;
	class MappedAttr;

/**
 * Class Description:
 * This is a mapper that can run on top of a Tango Server exporting attributes.
 *	Those attributes can be mapped into other attributes, with other names
 *	and other dimensions.
 *	The configuration is made acting on the device properties.
 */

/*
 *	Device States Description:
 */


class TangoDevMapper: public TANGO_BASE_CLASS
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	Each line of the property describes how one attribute of the lower device
 *	server has to be mapped into one or more attributes of the device mapper..
 *	As to the way they are built, the attributes are all scalars.
 *	Examples:
 *	
 *	CurrentArray:current1,current2,current3
 *	SIP120_S2.10_PRES_RR:pressure
 *	
 *	In the first case, the attribute CurrentArray is split into three scalar attributes.
 *	The attribute CurrentArray must be long more than 3 elements.
 *	If it is greater, the first 3 elements are taken.
 *	If it is shorter, an error occurs.
 *	In the second case, the attribute is mapped one to one, and hopefully
 *	the SIP120_S2.10_PRES_RR is itself a scalar and, if spectrum, only its
 *	first element is mapped.
 *	
 */
	vector<string>	map;
/**
 *	The lower level tango device.
 *	The lower level tango device will have its attributes mapped into the
 *	attributes of this device.
 *	The device name must be in the usual form:
 *	domain/family/member, e.g.:
 *	test/device/1
 */
	string	tangoDevice;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	TangoDevMapper(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	TangoDevMapper(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	TangoDevMapper(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~TangoDevMapper() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name TangoDevMapper methods prototypes
 */

//@{

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	

	
	void read_attr_hardware(vector<long> &attr_list);
	void write_MappedAttr(Tango::WAttribute &attr);
	void read_MappedAttr(Tango::Attribute &attr);
	bool is_MappedAttr_allowed(Tango::AttReqType type);



protected :	
	//	Add your own data members here
	//-----------------------------------------
	
	private:
		vector<string> split_attmap(string s);
		vector<string> split(string s, const char delim);
		void setupAttributesProperties();
		std::map<string, DeviceProxy*> namesDevsMap;
		std::map<string, MappedAttr *>attributesMap;
		void setupDevice(MappedAttr *);
		bool addAttributeToAttributeMap(MappedAttr *);
		DeviceProxy * findOpenDevices(string dname);
};

}	// namespace_ns

#endif	// _TANGODEVMAPPER_H
