//=============================================================================
//
// file :         TangoDevMapperClass.h
//
// description :  Include for the TangoDevMapperClass root class.
//                This class is represents the singleton class for
//                the TangoDevMapper device class.
//                It contains all properties and methods which the 
//                TangoDevMapper requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: claudio $
//
// $Revision: 1.2 $
//
// $Log: TangoDevMapperClass.h,v $
// Revision 1.2  2012-05-07 10:33:52  claudio
// tango-7.2.6
// meno printf
//
// Revision 1.1.1.1  2008/04/28 09:17:54  giacomo
// Prima release di TangoDevMapper. Aprile 2008
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _TANGODEVMAPPERCLASS_H
#define _TANGODEVMAPPERCLASS_H

#include <tango.h>
#include <TangoDevMapper.h>


namespace TangoDevMapper_ns
{//=====================================
//	Define classes for attributes
//=====================================
//=========================================
//	Define classes for commands
//=========================================
//
// The TangoDevMapperClass singleton definition
//

class
#ifdef _TG_WINDOWS_ 
	__declspec(dllexport)
#endif
	TangoDevMapperClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static TangoDevMapperClass *init(const char *);
	static TangoDevMapperClass *instance();
	~TangoDevMapperClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	TangoDevMapperClass(string &);
	static TangoDevMapperClass *_instance;
	void command_factory();
	void get_class_property();
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace TangoDevMapper_ns

#endif // _TANGODEVMAPPERCLASS_H
